'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DEFAULT_WIDTH = 640;
var DEFAULT_HEIGHT = 360;

var hasGetUserMedia = function hasGetUserMedia() {
  if (!navigator) {
    return false;
  }
  return !!navigator.mediaDevices.getUserMedia;
};

var styles = {
  container: {
    position: 'relative'
  },
  button: {
    position: 'absolute',
    bottom: '3em',
    left: '0.5em',
    color: '#ffffff',
    backgroundColor: '#5dade2',
    padding: '0.5em 1.5em',
    fontSize: '1em',
    fontWeight: 'bold'
  }
};

var ImageCapture = function (_Component) {
  _inherits(ImageCapture, _Component);

  function ImageCapture(props) {
    _classCallCheck(this, ImageCapture);

    var _this = _possibleConstructorReturn(this, (ImageCapture.__proto__ || Object.getPrototypeOf(ImageCapture)).call(this, props));

    _this.takePicture = _this.takePicture.bind(_this);
    _this.state = {
      hasGetUserMedia: false
    };
    return _this;
  }

  _createClass(ImageCapture, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      var _props = this.props,
          height = _props.height,
          width = _props.width;


      var isEnabled = hasGetUserMedia();

      this.setState({ // eslint-disable-line react/no-did-mount-set-state
        hasGetUserMedia: isEnabled
      });

      if (isEnabled) {
        navigator.mediaDevices.getUserMedia({ video: { width: width, height: height } }).then(function (stream) {
          _this2.video.srcObject = stream;
          _this2.video.play();
        }).catch(function (err) {
          console.error('An error occured! ', err); // eslint-disable-line no-console
        });
      }
    }
  }, {
    key: 'takePicture',
    value: function takePicture(event) {
      var _props2 = this.props,
          height = _props2.height,
          width = _props2.width;


      event.preventDefault();
      this.canvas.getContext('2d').drawImage(this.video, 0, 0, width, height);
      var img = this.canvas.toDataURL('image/png');
      this.props.takePicture(img);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _props3 = this.props,
          buttonTitle = _props3.buttonTitle,
          height = _props3.height,
          width = _props3.width,
          _props3$customStyles = _props3.customStyles;
      _props3$customStyles = _props3$customStyles === undefined ? styles : _props3$customStyles;
      var _props3$customStyles$ = _props3$customStyles.container,
          containerStyle = _props3$customStyles$ === undefined ? styles.container : _props3$customStyles$,
          _props3$customStyles$2 = _props3$customStyles.button,
          buttonStyle = _props3$customStyles$2 === undefined ? styles.button : _props3$customStyles$2;

      return _react2.default.createElement(
        'div',
        { style: containerStyle },
        _react2.default.createElement('video', { ref: function ref(video) {
            _this3.video = video;
          }, width: width, height: height }),
        _react2.default.createElement(
          'button',
          {
            ref: function ref(button) {
              _this3.button = button;
            },
            onClick: this.takePicture,
            style: buttonStyle
          },
          buttonTitle
        ),
        _react2.default.createElement('canvas', { width: width, height: height, ref: function ref(canvas) {
            _this3.canvas = canvas;
          }, style: { display: 'none' } }),
        _react2.default.createElement(
          'p',
          null,
          '' + this.state.hasGetUserMedia
        )
      );
    }
  }]);

  return ImageCapture;
}(_react.Component);

ImageCapture.defaultProps = {
  buttonTitle: 'Take picture',
  customStyles: styles,
  height: DEFAULT_HEIGHT,
  width: DEFAULT_WIDTH
};

ImageCapture.propTypes = {
  buttonTitle: _propTypes2.default.string,
  customStyles: _propTypes2.default.object, // eslint-disable-line react/forbid-prop-types
  height: _propTypes2.default.number,
  takePicture: _propTypes2.default.func.isRequired,
  width: _propTypes2.default.number
};

exports.default = ImageCapture;